package com.ophone.dazhihui.http;

import java.io.OutputStream;
import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.io.UnsupportedEncodingException;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.InetSocketAddress;
import java.net.Proxy;
import java.net.Socket;
import java.net.URL;
import java.net.URLEncoder;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.android.dazhihui.http.HttpConstants;
import com.android.dazhihui.http.Request;
import com.android.dazhihui.http.Response;
import com.android.dazhihui.common.GlobeAdapter;
import com.android.dazhihui.GameConstCustom;
import com.android.dazhihui.Globe;

/**
 * Ophone平台下应用Http通讯的网络接口类
 */
public class HttpClient {
    private HttpURLConnection conn = null;

    private Socket sconn = null;

    private URL mURL = null;

    private InputStream inputStream = null;

    private OutputStream outputStream = null;

    private Request request = null;

    public static final int TIMEOUT_CONNECT = 30000;
	public static final int TIMEOUT_READ = 90000;
	 private int proxy_port;
    private String proxy_host;

	public HttpClient(String proxy_host,int proxy_port) {
    	this.proxy_host = proxy_host;
    	this.proxy_port = proxy_port;
    }

    //#if Android_LV2

	int len = 0;
    private long time = 0;
    public Response getResponse(Request request) throws Exception {
        if (request == null) {
            return null;
        }

        try {
            GlobeAdapter.dataTime = 0;
            GlobeAdapter.dataLength = 0;
            this.request = request;
            Response resp = new Response();


            switch (request.getServerKind()) {
			case GameConstCustom.SERVER_KIND_HANG:
				makeConnectionHang();
				break;
			case GameConstCustom.SERVER_KIND_TRADE_HANG: //委托行情
				makeConnectionTradeHang();
				break;
            case GameConstCustom.SERVER_KIND_TRADE:
                makeConnectionTrade();
                break;
            case GameConstCustom.SERVER_KIND_MESSAGE:
                makeConnectionMessage();
                break;
            }
			byte[] tmp;
			if (!(request.getServerKind() == GameConstCustom.SERVER_KIND_TRADE)) {
				resp.responseCode = conn.getResponseCode();
				if (resp.responseCode == 302 || resp.responseCode == 301) { //自动跳转
					String url = conn.getHeaderField("Location"); //新地址
					if (url != null && url.startsWith("/*")) {
						StringBuffer b = new StringBuffer();
						b.append("http://");
						b.append(conn.getURL().getHost());
						b.append(':');
						b.append(conn.getURL().getPort());
						b.append(url);
						url = b.toString();
					}
					resp.nextUrl = url;
					resp.setScreenId(request.getScreenId());
					resp.setCommId(request.getCommId());
					return resp;
				}

                //注意 HeaderField中大小写不敏感
				String strContentLength = conn.getHeaderField("content-length");

				if (strContentLength != null) {
					resp.contentLength = Integer.parseInt(strContentLength);
					//Logger.Log("strContentLength=" + strContentLength);
				}

				resp.wmlUrl = request.getWmlUrl();
				resp.setScreenId(request.getScreenId());
				resp.setCommId(request.getCommId());
				tmp = readResponse();
			} else {
				String strContentLength = conn.getHeaderField("content-length");
				if (strContentLength != null) {
					len = Integer.parseInt(strContentLength);
				}
				resp.setScreenId(request.getScreenId());
				resp.setCommId(request.getCommId());
				tmp = readByteStream();
				//Logger.Log("id:  " + request.getCommId());
			}
			resp.analysisData(tmp); //数据进行解析
			GlobeAdapter.dataTime = System.currentTimeMillis() - time;
//			Logger.Log("http analysis ok! Time ="
//					+ (System.currentTimeMillis() - time));
			return resp;
        } catch (Exception e) {
            e.printStackTrace();

            return null;
        } finally {
        	cleanup();
        	if(Globe.GprsChoice!= GameConstCustom.CONNECT_CMNET && request.getServerKind() == GameConstCustom.SERVER_KIND_HANG){
	            mURL = new URL("http://" + GlobeAdapter.serHangIP);
	        	if ((proxy_host != null) && (proxy_host.length() > 0)) {
	    			if (proxy_port <= 0)
	    				proxy_port = GlobeAdapter.port;
	    			Proxy proxy = new Proxy(java.net.Proxy.Type.HTTP,
	    					new InetSocketAddress(proxy_host, proxy_port));
	    			conn = (HttpURLConnection) mURL.openConnection(proxy);
	    		} else
	    			conn = (HttpURLConnection) mURL.openConnection();

	    		if (conn == null)
	    			throw new IOException("URLConnection instance is null");


	            conn.setRequestProperty("Content-Type", "application/octet-stream");
	            conn.setRequestMethod("POST");
        	}
        	this.request = null;
        }
    }


    private void makeConnectionHang() throws Exception {
        //Logger.Log("GlobeAdapter.serHangIP = " + GlobeAdapter.serHangIP);
        //Logger.Log("GlobeAdapter.GprsChoice = "+Globe.GprsChoice);
        mURL = new URL("http://" + GlobeAdapter.serHangIP);

    	if ((GlobeAdapter.proxy != null) && (GlobeAdapter.proxy.length() > 0)) {
			if (GlobeAdapter.port <= 0)
				GlobeAdapter.port = 80;
			Proxy proxy = new Proxy(java.net.Proxy.Type.HTTP,
					new InetSocketAddress(GlobeAdapter.proxy, GlobeAdapter.port));
			conn = (HttpURLConnection) mURL.openConnection(proxy);
		} else
			conn = (HttpURLConnection) mURL.openConnection();

    	if (conn == null)
			throw new IOException("URLConnection instance is null");

    	//conn.setConnectTimeout(10000);

        conn.setRequestProperty("accept", "*/*");
        conn.setRequestProperty("connection", "Keep-Alive");
        conn.setRequestProperty("Content-Type", "application/octet-stream");
        conn.setRequestMethod("POST");


        //Logger.Log("conn over");
        conn.setUseCaches(false);
        conn.setDoInput(true);
        conn.setDoOutput(true);

        byte[] data = request.getContent();
        //Logger.Log("getContent over");
        if(data!=null)
        	conn.setRequestProperty("Content-Length", String.valueOf(data.length));

        if ( data!= null) {
            outputStream = conn.getOutputStream();
            outputStream.write(data);
            outputStream.flush();//编码变成 chunked
        }

        //Logger.Log("send length = " + data.length);
        inputStream = conn.getInputStream();
    }

		private void makeConnectionTradeHang () throws Exception
	   {
	       //Logger.Log("GlobeAdapter.serTradeIP = " + GlobeAdapter.serTradeIP);
	        mURL = new URL("http://" + GlobeAdapter.serTradeIP);
	    	if ((GlobeAdapter.proxy != null) && (GlobeAdapter.proxy.length() > 0)) {
				if (GlobeAdapter.port <= 0)
					GlobeAdapter.port = 80;
				Proxy proxy = new Proxy(java.net.Proxy.Type.HTTP,
						new InetSocketAddress(GlobeAdapter.proxy, GlobeAdapter.port));
				conn = (HttpURLConnection) mURL.openConnection(proxy);
			} else
				conn = (HttpURLConnection) mURL.openConnection();

	    	if (conn == null)
				throw new IOException("URLConnection instance is null");


	        conn.setRequestProperty("accept", "*/*");
	        conn.setRequestProperty("connection", "Keep-Alive");
	        conn.setRequestProperty("Content-Type", "application/octet-stream");
	        conn.setRequestMethod("POST");


	        //Logger.Log("conn over");
	        conn.setUseCaches(false);
	        conn.setDoInput(true);
	        conn.setDoOutput(true);

	        byte[] data = request.getContent();
	        //Logger.Log("getContent over");
	        if(data!=null)
	        	conn.setRequestProperty("Content-Length", String.valueOf(data.length));

	        if ( data!= null) {
	            outputStream = conn.getOutputStream();
	            outputStream.write(data);
	            outputStream.flush();
	        }

	       inputStream = conn.getInputStream();
	   }

		private void makeConnectionTrade () throws Exception
		   {
		       //Logger.Log("GlobeAdapter.serTradeIP = " + GlobeAdapter.serTradeIP);
		        mURL = new URL("http://" + GlobeAdapter.serTradeIP);
		    	if ((GlobeAdapter.proxy != null) && (GlobeAdapter.proxy.length() > 0)) {
					if (GlobeAdapter.port <= 0)
						GlobeAdapter.port = 80;
					Proxy proxy = new Proxy(java.net.Proxy.Type.HTTP,
							new InetSocketAddress(GlobeAdapter.proxy, GlobeAdapter.port));
					conn = (HttpURLConnection) mURL.openConnection(proxy);
				} else
					conn = (HttpURLConnection) mURL.openConnection();

		    	if (conn == null)
					throw new IOException("URLConnection instance is null");


		        conn.setRequestProperty("accept", "*/*");
		        conn.setRequestProperty("connection", "Keep-Alive");
		        conn.setRequestProperty("Content-Type", "application/octet-stream");
		        conn.setRequestMethod("POST");


		        //Logger.Log("conn over");
		        conn.setUseCaches(false);
		        conn.setDoInput(true);
		        conn.setDoOutput(true);

		        byte[] data = request.getContent();
		        //Logger.Log("getContent over");
		        if(data!=null)
		        	conn.setRequestProperty("Content-Length", String.valueOf(data.length));

		        if ( data!= null) {
		            outputStream = conn.getOutputStream();
		            outputStream.write(data);
		            outputStream.flush();
		        }

		       inputStream = conn.getInputStream();
		   }

	   private byte[] readByteStream () throws Exception
	   {
	   	byte[] data = null;
	       if (len > 0)
	       {
	           data = new byte [len];
	           int offset = 0;
	           for (; offset < len; )
	           {
	               int read = inputStream.read (data, offset, len - offset);
	               if (read == -1) break;
	               offset += read;
	           }
	           if (offset != len) throw new IOException ("数据未收全IOException: " + offset + "/" + len);
	       }
	       else
	       {
	           ByteArrayOutputStream bo = new ByteArrayOutputStream (1024);
	           while (true)
	           {
	               int v = inputStream.read ();
	               if (v == -1) break;
	               bo.write (v);
	           }
	           data = bo.toByteArray ();
	       }
	       if (data != null && data.length > 0){}
	       return data;
	}

    private void makeConnectionMessage() throws Exception {
    	String url = request.getWmlUrl();

    	url = encode(url,"UTF-8");

        mURL = new URL(url);

    	if ((GlobeAdapter.proxy != null) && (GlobeAdapter.proxy.length() > 0)) {
			if (GlobeAdapter.port <= 0)
				GlobeAdapter.port = 80;
			Proxy proxy = new Proxy(java.net.Proxy.Type.HTTP,
					new InetSocketAddress(GlobeAdapter.proxy, GlobeAdapter.port));
			conn = (HttpURLConnection) mURL.openConnection(proxy);
		} else
			conn = (HttpURLConnection) mURL.openConnection();

    	if (conn == null)
			throw new IOException("URLConnection instance is null");

    	//conn.setConnectTimeout(10000);

    	conn.setRequestProperty("accept", "*/*");
    	conn.setRequestProperty("connection", "Keep-Alive");

        conn.connect();

        inputStream = conn.getInputStream();

    }

    private static String zhPattern = "[\u4e00-\u9fa5]+";


    /**
     * 替换字符串卷
     * @param str
     * @param charset
     * @return
     * @throws UnsupportedEncodingException
     */
    public static String encode(String str, String charset) throws UnsupportedEncodingException {
      Pattern p = Pattern.compile(zhPattern);
      Matcher m = p.matcher(str);
      StringBuffer b = new StringBuffer();
      while (m.find()) {
        m.appendReplacement(b, URLEncoder.encode(m.group(0), charset));
      }
      m.appendTail(b);
      return b.toString();
    }


    private byte[] readResponse() throws Exception {
        try {
            byte[] data = null;
            if (conn != null && inputStream != null) {
                ByteArrayOutputStream tmp = new ByteArrayOutputStream();
                byte[] buffer = new byte[HttpConstants.BUFFER_SIZE];
                int count;
                while ((count = inputStream.read(buffer, 0, HttpConstants.BUFFER_SIZE)) != -1) {
                    tmp.write(buffer, 0, count);
                    GlobeAdapter.dataLength += count;
                }
                data = tmp.toByteArray();
                tmp.close();
                tmp = null;
                buffer = null;
            }
            return data;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    private byte[] Socket2http() throws Exception {

        cleanup();
        String url = request.getWmlUrl();
        //Logger.Log("" + url);
        if (url.startsWith("http://mnews.gw.com.cn")) {
            url = url.substring(22, url.length());
        }

        sconn = new Socket("114.80.107.87",8083);
        sconn.setSendBufferSize(1024);
        sconn.setReceiveBufferSize(10*1024);

        ByteArrayOutputStream bo = new ByteArrayOutputStream(1024);
        bo.write(("POST " + url + " HTTP/1.0\r\n").getBytes());
        bo.write("Content-Type: application/octet-stream\r\n".getBytes());
        bo.write("Accept: application/vnd.wap.xhtml+xml,application/xml,text/vnd.wap.wml,text/html,application/xhtml+xml,image/jpeg;q=0.5,image/png;q=0.5,image/gif;q=0.5,image/*;q=0.6,video/*,audio/*,*/*;q=0.6\r\n".getBytes());
        bo.write(("Content-Length: 0\r\n\r\n").getBytes());

        outputStream = sconn.getOutputStream();
        outputStream.write(bo.toByteArray());
        outputStream.flush();

        inputStream = sconn.getInputStream();
        int rc = 0;
        StringBuffer buf = new StringBuffer(256);
        int v = 0;
        String line = null;
        int strContentLength = 0;

        while ((v = inputStream.read()) != -1) {
            if (v == '\n') {
                line = buf.toString().trim().toUpperCase();
                if (line.length() == 0) {
                    break;
                } else if (line.startsWith("HTTP")) {
                    int p1 = line.indexOf(' ');
                    int p2 = line.indexOf(' ', p1 + 1);
                    rc = Integer.parseInt(line.substring(p1 + 1, p2).trim());
                } else if (line.startsWith("CONTENT-LENGTH")) {
                    int p1 = line.indexOf(':');
                    strContentLength = Integer.parseInt(line.substring(p1 + 1).trim());
                }
                buf.delete(0, buf.length());
            } else {
                buf.append((char) v);
            }
        }

        if (rc != 200) {
            return null;
        }

        byte[] data = null;
        if (strContentLength > 0) {
            data = new byte[strContentLength];
            int offset = 0;
            for (; offset < strContentLength; ) {
                int read = inputStream.read(data, offset, strContentLength - offset);
                if (read == -1) {
                    break;
                }
                offset += read;
                GlobeAdapter.dataLength += read;
            }
            if (offset != strContentLength) {
                throw new IOException("数据未收全IOException:" + offset + "/" + strContentLength);
            }
        } else {
            ByteArrayOutputStream baout = new ByteArrayOutputStream(1024);
            while (true) {
                v = inputStream.read();
                if (v == -1) {
                    break;
                }
                baout.write(v);
            }
            data = baout.toByteArray();
        }

        return data;

    }


    public void cleanup() {
        try {
            if (inputStream != null) {
                inputStream.close();
                inputStream = null;
            }
            if (outputStream != null) {
                outputStream.close();
                outputStream = null;
            }
            if (conn != null) {
//                conn.close();
            	conn.disconnect();
                conn = null;
            }
            if (sconn != null) {
                sconn.close();
                sconn = null;
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
