package com.ophone.dazhihui.http;

import java.util.Vector;

import android.os.Handler;
import android.os.Message;

import com.android.dazhihui.http.CommonHttpHandler;
import com.android.dazhihui.http.HttpConstants;
import com.android.dazhihui.http.HttpListener;
import com.android.dazhihui.http.HttpMonitor;
import com.android.dazhihui.http.Request;
import com.android.dazhihui.http.Response;
import com.android.dazhihui.GameConstCustom;


public class HttpHandler implements CommonHttpHandler{

    private boolean isRunning = false;
    //Http client
    private HttpClient httpClient = null;
    //超时时间
    private int timeout;
    //重新连接次数
    private int retries;
    //HttpListener
    private HttpListener httpListener = null;
    //Http监视器
    private HttpMonitor monitor = null;

    //等待发送的缓冲请求信息
    private Vector vctRequests = new Vector();

    private long lWaitTime = 0;

    private int state = STATE_REST;
    private final static int STATE_REST = 0;
    private final static int STATE_CANCEL = 1;
    private final static int STATE_ACTIVE = 2;
    
    private static final int MESSAGETYPE_01 = 0x0001;

    private int proxy_port;
    private String proxy_host;
    private Response httpHandle_resp;
    
    private Request httpRequest;
    
    private ConnectThread connectThread = null;
    
    /*public HttpHandler(HttpListener httpListener) {
        this(HttpConstants.DEFAULT_OVERTIME, HttpConstants.DEFAULT_RETRIES, httpListener);
    }*/

    public HttpHandler(HttpListener httpListener,String proxy_host,int proxy_port) {
    	this.proxy_port = proxy_port;
    	this.proxy_host = proxy_host;
    	
    	setConst(HttpConstants.DEFAULT_OVERTIME, HttpConstants.DEFAULT_RETRIES, httpListener);
        
    }
	public void setConst(int timeout, int retries, HttpListener httpListener){
    	this.retries = retries;
        this.timeout = timeout;
        this.httpListener = httpListener;
        this.isRunning = true;
        httpClient = new HttpClient(proxy_host,proxy_port);
        


        new Thread(this).start();

    }

    public void setHttpListener(HttpListener httpListener) {
        this.httpListener = httpListener;
    }


    public void run() {
        while (isRunning) {
            try {
            	 if (vctRequests.size() > 0) {
//            		 System.out.println("http run");
                     lWaitTime = 0;
                     Request request = null;
                     synchronized (vctRequests) {
                         if (vctRequests.size() > 0) {
                             request = (Request) vctRequests.elementAt(0);
                             vctRequests.removeElementAt(0);
                         }
                     }
                     Response tempResp= getResponse(request);
                     if(tempResp.getScreenId()==GameConstCustom.HEART_ID){
                     }else{
                         httpHandle_resp = tempResp; 
                     }
                     if (httpHandle_resp != null) {
//                         if (httpListener != null) {
//                         	httpListener.completed(httpHandle_resp);
//                    	 	System.out.println("http send");
                        	mRedrawHandler.removeMessages(0); //clear all messages in MQ
             				Message msg= mRedrawHandler.obtainMessage(1, 1, 1, "Message order"); 
             				mRedrawHandler.sendMessage(msg);
//                         }
//                         httpHandle_resp = null;
                     }
            	}
            	
				
				Thread.sleep(100);
            } catch (Exception ex) {

            }
        }
    }
    
    private RefreshHandler mRedrawHandler = new RefreshHandler();

    class RefreshHandler extends Handler {
        @Override
        public void handleMessage(Message msg) {
                if (httpHandle_resp != null) {
                    if (httpListener != null) {
                    	httpListener.completed(httpHandle_resp);
                    }
                    httpHandle_resp = null;
                }
        }
    };

	boolean isRetryTimes;
    private void handleException(Exception ex) {
        if (httpListener != null && state == STATE_ACTIVE) {
            try {
            	//Logger.Log("handleException");
            	//mRedrawHandler.removeMessages(0);
                httpListener.exception(ex, this);
				isRetryTimes = true;
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * Provides an interrupt to the initiated request.  This method is typically
     */
    public void timeout() {
        cleanup();

        handleException(new Exception("Timeout!!"));
    }

    public void sendRequest(Request request) {
    	this.httpRequest = request;
    	 connectThread = new ConnectThread();
         connectThread.start();
    }
    
    class ConnectThread extends Thread {
        public void run() {
          if (httpRequest == null) {
          return;
	      }
	      
//	      synchronized (vctRequests) {
	      	if (vctRequests.size() > 0) {
	              vctRequests.removeAllElements();
	          }
	          vctRequests.addElement(httpRequest);
//	      }
            connectThread = null;
        }
    }

    public Response getResponse(Request request) {
        Response resp = null;

        int thisTry = 1;
        while (thisTry <= retries&&isRunning) {

            try {
                startTimer();
                state = STATE_ACTIVE;
                resp = httpClient.getResponse(request);

                //Logger.Log("resp="+resp.toString());
                stopTimer();
                state = STATE_REST;

                break;
            } catch (Exception e) {

                stopTimer();

                if (state == STATE_CANCEL) {
                    state = STATE_REST;
                    break;
                } else if (thisTry >= retries) {
                	//Logger.Log("retris over 3");
                    handleException(e);
                    cleanup();
                }
                state = STATE_REST;
            } finally {
                thisTry++;
            }
        }

        return resp;
    }
    
    public void destroy() {
		try {
			isRunning = false;
			httpListener = null;
			if (httpClient != null) {
				httpClient.cleanup();
				httpClient = null;
			}
			this.cancelTimer();
			monitor = null;
			synchronized (vctRequests) {
				vctRequests.removeAllElements();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
    
    public void cleanup() {
        try {
            this.cancelTimer();
            monitor = null;

            if(httpClient!=null)
            	httpClient.cleanup();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public int getVctRequests() {
        synchronized (vctRequests) {
            return vctRequests.size();
        }
    }

    public void stop() {
        synchronized (vctRequests) {
            vctRequests.removeAllElements();
        }

        httpListener = null;
        cleanup();

        isRunning = false;
        httpClient = null;

    }

    public void cancelAccess() {
        if (state == STATE_ACTIVE) {
            state = STATE_CANCEL;
            cleanup();
        }
    }

    public void startTimer() {
        if (timeout > 0) {
            monitor = getRequestTimer();
            monitor.startTimer();
        }
    }

    private HttpMonitor getRequestTimer() {
        if (monitor == null) {
            monitor = new HttpMonitor(this, timeout);
            monitor.start();
        }
        return monitor;
    }

    public boolean isCleanup() {
        if (monitor == null) {
            return true;
        }
        return false;
    }
    
    /**
     * Issues a stopTimer() call to the <code>SocketMonitor</code>.
     * @see java.io.InputStream
     */
    public void stopTimer() {
        if (timeout > 0 && monitor != null) {
            monitor.stopTimer();
        }
    }

    /**
     * Issues a cancelTimer() call to the <code>SocketMonitor</code>.
     */
    public void cancelTimer() {
        if (timeout > 0) {
            if (monitor != null) {
                monitor.cancelTimer();
            }
        }
    }

    public void pauseTimer() {
        if (monitor != null) {
            monitor.pauseMonitor();
        }
    }

    public void resumeTimer() {
        if (monitor != null) {
            monitor.resumeMonitor();
        }
    }
    

	   private static int ID = -1;

    public void sendRequest (Request request, int ID)
	   {
		   	if(ID!=GameConstCustom.HEART_ID){
		   		HttpHandler.ID = ID;
		   	}  	   	
	    	this.httpRequest = request;
	    	connectThread = new ConnectThread();
	        connectThread.start();
	   }
	   
	   public static int getID ()
	   {
	   	return ID;
	   }
	   public static void reSetID ()
	   {
		   ID = -1;
	   }
}
