// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

    // setup an abstract state for the tabs directive
    // .state('tab', {
    //   url: "/tab",
    //   abstract: true,
    //   templateUrl: "templates/tabs.html"
    // })

    // Each tab has its own nav history stack:

    .state('list', {
      url: '/list/:placeId',
      templateUrl: 'templates/tab-list.html',
      controller: 'ListCtrl'
    })

    .state('businessDetail', {
      url: '/businessDetail/:bussinessHallId',
      templateUrl: 'templates/tab-businessDetail.html',
      controller: 'BusinessDetailCtrl'

    })

    .state('map', {
      url: '/map/:location',
      templateUrl: 'templates/tab-map.html',
      controller: 'MapCtrl'

    })

    .state('choosePlace', {
      url: '/choosePlace',
      templateUrl: 'templates/tab-choosePlace.html',
      controller: 'ChoosePlaceCtrl'

    });


  var loginin = window.getBusinessList.islogin();
  var gpsInformation = window.getBusinessList.getGPS1();
  if(loginin){
     $urlRouterProvider.otherwise('/businessDetail/-1');
  }else{
     
    // 判断GPS信息是否获取到，如果没有，请用户选择地区，如果获取到了，则显示列表
     if(gpsInformation == "" || gpsInformation == ".0000"){
        $urlRouterProvider.otherwise('/choosePlace');
    }else{
        $urlRouterProvider.otherwise('/list/-1');
    }

    // use html directively get the position information
    // navigator.geolocation.getCurrentPosition(onSuccess, onError);
    //         //成功获取地理位置
    //         function onSuccess(position) { 
    //           $urlRouterProvider.otherwise('/list/-1');
    //        } 

    //         //未成功获取地理位置
    //         function onError(error) { 
    //             $urlRouterProvider.otherwise('/choosePlace');
    //         } 
    
  }
  // if none of the above states are matched, use this as the fallback
  //$urlRouterProvider.otherwise('/list');

});
