/*!
 * Bridge.js v1.0.1
 *  edit by adeline Wu
 *  2016/8/8
 */
(function(window) {
    var DEBUG = true;
    var callbacks = {};
    var guid = 0;
    var ua = navigator.userAgent;
    // TODO 精确性待改进
    var ANDROID = /android/i.test(ua);
    var IOS = /iphone|ipad/i.test(ua);
    var WP = /windows phone/i.test(ua);
    //ANDROID = 0; IOS = 1;

    /**
     * 方便在各个平台中看到完整的 log
     */
    function log() {
        if (DEBUG) {
            console.log.call(console, Array.prototype.join.call(arguments, ' '));
        }
    }

    /**
     * 平台相关的 Web 与 Native 单向通信方法
     */
    function invoke(cmd) {
        log('invoke', cmd);
        

        if (ANDROID) {
            //location.href = "gtjayyznativetransmit://" + cmd;
            prompt("gtjayyznativetransmit://" + cmd);
        }
        else if (IOS) {
            var url = cmd;
            //location.href = escape("gtjayyznativetransmit://" + url);
            location.href = encodeURIComponent("gtjayyznativetransmit://" + url);
        }
        else if (WP) {
            // TODO ...
        }
    }

    var Bridge = {
        callByJS: function(opt) {
            log('callByJS', JSON.stringify(opt));
            
            var input = {};
            input.id = opt.id
            input.tranCode = opt.tranCode;
            //input.jsToken = ++guid;
            input.jsToken = opt.jsToken;
            input.isEncrypt = opt.isEncrypt;
            input.transmitMode = opt.transmitMode;
            input.publicParameter = opt.publicParameter;
            input.param = opt.param || {};
            input.localParameter = opt.localParameter;
            callbacks[input.jsToken] = opt.callback;

            invoke(JSON.stringify(input));
        },
        callByNative: function(optStr) {
            log('callByNative', JSON.stringify(optStr));

            var opt = JSON.parse(optStr);
            var callback = callbacks[opt.jsToken];
            var ret = opt.ret || {};
            var script = opt.script || '';

            // Native 主动调用 Web
            if (script) {
                log('callByNative script', script);
                try {
                    invoke(JSON.stringify({
                        token: opt.jsToken,
                        ret: eval(script)
                    }));
                } catch (e) {
                    console.error(e);
                }
            }
            // Web 主动调用 Native，Native 被动的响应
            else if (callback) {
            	log('callByNative callback', script);
            	//ret中包含error,data两种信息，只有当error为0时，才调用回调方法
            	if(ret.error == "0"){
            		callback(ret);
            	}else{
            		//出错信息，1、未登录 2、已登录，但是有其他错误
                    //alert(JSON.stringify(ret.data));
                    //messageDialog为通用函数，为显示错误提示框的专用函数名
                    //callback("bridgeerror" + ret);
                    callback(ret);
            	}
                
                try {
                    delete callback;
                    log(callbacks);
                } catch (e) {
                    console.error(e);
                }
            }

        }
    };

    window.Bridge = Bridge;
    window.__log = log;
})(window);